//
//  LalamoveInterface.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/7/29.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
import Alamofire
import SwiftyJSON
import ObjectMapper
//MARK:--获取已开通城市列表
//params-key(user_name(用户名),pwd(密码))
func cityList(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("获取已开通城市列表", params, { (rep:DataResponse<cityListModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--物流预估价格
//params-key(nonce_str city_id  city_info_revision下单城市版本号 order_vehicle_id 车型ID  std_tag_arr用户选择的车型附加要求,(中文，多个用逗号拼接)spec_req_arr用户选择的城市额外需求,(数字值，多个用逗号拼接)    lat_lon_arr 地址信息,二维数组，josn格式，字段如下    lat_lon_arr 字段：由发货地经纬度+城市Id 和 收发货地经纬度+城市Id 组成的二维数组，转json格式，例：
//[{“lat”:23.149393205825, “lon”:113.25378640268,”city_id”:1001}, {“lat”:23.172258837638, “lon”:113.2305979752,”city_id”:1001}])
func orderPriceCalculate(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("物流预估价格", params, { (rep:DataResponse<orderPriceCalculateModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--地址检索poi
//params-key(nonce_str    随机字符串,用户自定义,60s内不可重复使用,仅用于保证签名不可预测 kw 搜索关键字 如:深圳北站 city 搜索城市(中文名称)， 如:深圳)
func citySearch(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("地址检索poi", params, { (rep:DataResponse<citySearchModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--货拉拉下单
//params-key
//{收件信息多个的话r_city、r_area、r_address、r_consignee、r_mobile则取最后一个
//  "user_token": 'SIIDsq213kl',
//  "nonce_str": "213223211",
//s_city    是    string    发件城市
//s_area    是    string    发件区
//s_address    否    string    详细地址
//s_consignee    否    string    联系人
//s_mobile    否    string    联系人电话
//r_city    是    int    收件城市
//r_area    是    string    收件区
//r_address    否    string    详细地址
//r_consignee    否    string    联系人
//r_mobile    否    string    联系人电话
//  "city_id": "1006",下单城市ID
//  "city_info_revision": "1156",下单城市版本号
//  "order_vehicle_id": "10",车型ID
//  "std_tag_arr": [ing    车型附加要求， 字符串数组；格式如：”[\”带尾板\”]”;值可取“获取城市可选车型信息”接口返回值中data.vehicle_arr[0].vehicle_std_arr.name的值作为成员
//    "带尾板",
//  ],
//  "spec_req_arr": [    订单额外服务， 整型数组；格式如：”[2, 3, 5]”；值可取“获取城市可选车型信息”接口返回值中data.spec_req_arr.type的值作为成员；1搬运 2小推车 3回单 4尾板 5返程 6回单拍照 7海外入仓 8代收货款；示例：2
//    "2",
//    "5"
//  ],
//  "addr_info": [    发/收货地poi数据列表。 可参考“根据关键字检索地址poi”接口返回值；array内容为地址信息数组
//    {
//      "lat_lon": {
//        "lat": "31.196027516575054",
//        "lon": "121.31625670047288"
//      },
//      "addr": "闵行区申贵路1500号",
//      "name": "申贵路1500号",
//      "city_id": "1006",
//      "district_name": "闵行区",
//      "house_number": "",
//      "contact_name": "",
//      "contact_phone_no": ""
//    },
//    {
//      "lat_lon": {
//        "lat": "31.202375193368646",
//        "lon": "121.32264161728554"
//      },
//      "addr": "长宁区人民医院",
//      "name": "人民医院",
//      "city_id": "1006",
//      "district_name": "长宁区",
//      "house_number": "",
//      "contact_name": "",
//      "contact_phone_no": ""
//    }
//  ],
//  "order_time": "1596167602",需用车时间
//  "total_price_fen": "    订单总金额(分)；示例：1800; 值来源:”计价”接口返回值data.total_price_fen",
//  "contact_name": "下单联系人",
//  "contact_phone_no": "下单联系人手机",
//  "pay_type": "支付方式(3 余额支付，8 账期额度支付)",
//  "order_reason": "用车原因",
//  "remark": "备注"
//  "sale_plat": "关联平台"
//  "remark": "关联订单号"
//}
func shopsAuthList(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("货拉拉下单", params, { (rep:DataResponse<shopsAuthListModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--选定地址添加收发货历史
//params-key(user_token poi货拉拉历史记录的坐标json信息，house_number    楼层及门牌号，contact_name联系人，contact_phone_no联系人手机 ，sr_type收发货类型：1发货 2收货)
func setSearchLog(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("选定地址添加收发货历史", params, { (rep:DataResponse<UpDataModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--查看收发货历史
//params-key(user_token ，sr_type收发货类型：1发货 2收货)
func getSearchLogList(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("查看收发货历史", params, { (rep:DataResponse<getSearchLogListModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--获取货拉拉预约时间
//params-key(user_token  )
func getHllTime(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("获取货拉拉预约时间", params, { (rep:DataResponse<getHllTimeModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--获取取消订单原因
//params-key(user_token  lwb_no)
func orderCancelReason(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("获取取消订单原因", params, { (rep:DataResponse<orderCancelReasonModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--取消货拉拉订单
//params-key(user_token  lwb_no，reason_id    取消订单原因，reason取消原因说明)
func orderLalamoveCancel(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("取消货拉拉订单", params, { (rep:DataResponse<UpDataModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:--查看货拉拉运单详情
//params-key(user_token  lwb_no )
func getHllOrderDetails(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("查看货拉拉运单详情", params, { (rep:DataResponse<getHllOrderDetailsModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
