//
//  LogisticsInterface.swift
//  GeliBusinessPlatform
//
//  Created by junye lu on 2020/7/4.
//  Copyright © 2020 junye lu. All rights reserved.
//

import Foundation
import Alamofire
import SwiftyJSON
import ObjectMapper
//MARK:--运单列表
/*
 user_token 验证token
 keyword 搜索关键词
 start_time 开始时间
 end_time 结束时间
 lc_id 物流公司id
 order_sn 关联订单号（也是食品网订单号）
 sale_plat 所属平台
 pay_status 运单运费支付状态：1待支付 2已支付 3已退款
 delivery_status 运单状态：1下单完成 2揽收成功 3运输中 4已签收 5已取消 6拒收 7再投
 */
func jdOrderList(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("运单列表", params, { (rep:DataResponse<LogisticsModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}

//MARK:--获取所有物流公司
/*
 user_token 验证token
 */
func lcAll(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("获取所有物流公司", params, { (rep:DataResponse<lcAllModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 下单期望上门时间
/*
 user_token 验证token
 */
func appointmentTime(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("下单期望上门时间", params, { (rep:DataResponse<appointmentTimeModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 物流费用预估
/*
 user_token 验证token s_city r_city weight volume
 */
func estimatedCost(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("物流费用预估", params, { (rep:DataResponse<registerModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}

//MARK:-- 运单详情
/*
 user_token 验证token
 */
func logisticsOrderDetails(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("运单详情", params, { (rep:DataResponse<logisticsOrderDetailsModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 取消运单
/*
 user_token 验证token
 wb_no 运单号

 */
func cancelLogisticsOrder(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("取消运单", params, { (rep:DataResponse<UpDataModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 支付运费
/*
 user_token 验证token
 wb_no 运单号

 */
func payDelivery(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("支付运费", params, { (rep:DataResponse<UpDataModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 下运单收发地址信息
/*
 user_token 验证token
 */
func getAddr(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("下运单收发地址信息", params, { (rep:DataResponse<GetAddrsInfoModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 提交运单
/*
 user_token 验证token
 */
func addLogisticsOrder(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("提交运单", params, { (rep:DataResponse<AddLogisticsOrderModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
//MARK:-- 运单跟踪

/*
 user_token 验证token
 id
 */
func LogisticsTracking(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("运单跟踪", params, { (rep:DataResponse<LogisticsTrackingModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}

//MARK:-- 获取城市下可选车型信息

/*
 user_token 验证token
 nonce_str
 city_id
 */
func cityCart(_ params:[String:Any],success:@escaping (_ res:Any)->(),failture:@escaping(_ error:Error)->()) {
    NetworkRequest.sharedInstance.postRequest("获取城市下可选车型信息", params, { (rep:DataResponse<cityCartModel>) in
    }, success: { (data) in
        success(data)
    }) { (error) in
        failture(error)
    }
}
